Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_import.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_import.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_import.cpp	(revision 88)
@@ -0,0 +1,139 @@
+#ifdef STATISTICS
+#include "Behavioural/include/Stat_binary_tree.h"
+
+namespace morpheo {
+namespace behavioural {
+
+#define string2operator(x) (x=="+")?add:((x=="-")?sub:((x=="*")?mul:((x=="/" )?div:((x=="++")?inc:dec))))
+
+  void Stat_binary_tree::import (std::string expr,
+                                 std::map<std::string, counter_t*> * operand)
+  {
+    const std::string delims  (" ");          // délimiteur : " "
+    const std::string numbers ("0123456789"); // délimiteur : " "
+    std::string::size_type index_begin, index_end;
+
+    Stat_binary_tree * tree = this;
+
+    index_begin = expr.find_first_not_of(delims);
+
+    while (index_begin != std::string::npos)
+      {
+	index_end = expr.find_first_of(delims, index_begin);
+
+	if (index_end == std::string::npos)
+	  {
+	    index_end = expr.length();
+	  }
+	
+	std::string str = expr.substr(index_begin, index_end-index_begin);
+	
+	// 3 possibilités :
+	//  * operator
+	//  * constante
+	//  * variable
+	{
+	  // Test constantes
+	  std::string::size_type index = str.find_first_not_of(numbers);
+	  if (index  == std::string::npos)
+	    {
+// 	      std::cout << " * c'est une constante." << std::endl; 
+              counter_t cst = atoi(str.c_str());
+
+              if (tree->_data_type == NONE)
+                change_type(cst);
+              else
+                if (tree==NULL)
+                  tree = new Stat_binary_tree (cst);
+                else
+                  tree = tree->insert_tree (cst);
+	    }
+	  else
+	    {
+	      // Test variables
+              std::map<std::string, counter_t*>::iterator it = operand->find(str);
+	      if (it != operand->end())
+		{
+// 		  std::cout << " * c'est une variable." << std::endl; 
+                  counter_t * var = it->second;
+
+                  if (tree->_data_type == NONE)
+                    change_type(var);
+                  else
+                    if (tree==NULL)
+                      tree = new Stat_binary_tree (var);
+                    else
+                      tree = tree->insert_tree (var);
+		}
+	      else
+		{
+		  if ((str == "+") or
+		      (str == "-") or
+		      (str == "*") or
+		      (str == "/"))
+		    {
+// 		      std::cout << " * c'est un operator à 2 opérandes." << std::endl; 
+		 
+                      operator_t op = string2operator(str);
+
+                      if (tree->_data_type == NONE)
+                        change_type(op);
+                      else
+                        if (tree==NULL)
+                          tree = new Stat_binary_tree (op);
+                        else
+                          tree = tree->insert_tree (op);
+		    }
+		  else
+		    {
+		      if ((str == "++") or
+			  (str == "--"))
+			{
+// 			  std::cout << " * c'est un operator à 1 opérande." << std::endl; 
+
+                          operator_t op = string2operator(str);
+                          
+                          if (tree->_data_type == NONE)
+                            change_type(op);
+                          else
+                            if (tree==NULL)
+                              tree = new Stat_binary_tree (op);
+                            else
+                              tree = tree->insert_tree (op);
+			}
+		      else
+			{
+// 			  std::cout << " * c'est autre chose." << std::endl; 
+			  throw(ERRORMORPHEO("Stat_binary_tree::string2tree",toString(_("expression '%s' doesn't a constant, a declarated variable or an operator.\n"),str.c_str())));
+			}
+		    }
+		}
+	    }
+	}
+
+	index_begin = expr.find_first_not_of(delims, index_end);
+
+	if (index_begin != std::string::npos)
+	  tree = tree->goto_next_root();
+      }
+
+    if (tree == NULL)
+      throw (ERRORMORPHEO("Stat_binary_tree::string2tree",_("The tree generated is empty.\n")));
+
+//     std::cout << "<Stat::string2tree> goto_top_level" << std::endl;
+
+    tree = tree->goto_top_level();
+
+//     std::cout << "<Stat::string2tree> valid" << std::endl;
+
+//     print();
+
+    if ((not tree->valid()) or (not valid()))
+      throw (ERRORMORPHEO("Stat_binary_tree::string2tree",_("the tree generated is invalid.\n")));
+
+//     std::cout << "<Stat::string2tree> End" << std::endl;
+  }
+  
+};
+};
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_valid.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_valid.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_valid.cpp	(revision 88)
@@ -4,24 +4,90 @@
 namespace morpheo {
 namespace behavioural {
+
   bool Stat_binary_tree::valid (void)
   {
+    if (_data_type == NONE)
+      return false;
+
     if ((_data_type == VARIABLE) or
 	(_data_type == CONSTANT))
       return ((_left  == NULL) and
-	      (_right == NULL) );
-
+              (_right == NULL) );
+    
     if (_data_type == OPERATOR_UNARY)
       return ((_right == NULL) and
-	      (_left  != NULL) and
-	      (_left->valid()));
+              (_left  != NULL) and
+              (_left->valid()));
 
     if (_data_type == OPERATOR_BINARY)
       return ((_left  != NULL ) and
-	      (_left ->valid()) and
-	      (_right != NULL ) and
-	      (_right->valid()));
+              (_left ->valid()) and
+              (_right != NULL ) and
+              (_right->valid()));
 
     return false;
   }
+
+  void Stat_binary_tree::print (uint32_t depth)
+  {
+    std::string tab = std::string(depth,'\t');
+    std::string sep = " ";
+    if (_data_type == NONE)
+      {
+        std::cout << tab << "<node> NONE (error)" << std::endl;
+
+        if (_left  != NULL)
+          _left ->print(depth+1);
+        if (_right != NULL)
+          _right->print(depth+1);
+      }
+
+    if ((_data_type == VARIABLE) or
+	(_data_type == CONSTANT))
+      {
+        std::cout << tab << "<leaf>"
+                  << " "
+                  << ((_left   == NULL)?"left  == NULL        ":"left  != NULL (error)")
+                  << " "
+                  << ((_right  == NULL)?"right == NULL        ":"right != NULL (error)")
+                  << std::endl;
+
+        if (_left  != NULL)
+          _left ->print(depth+1);
+        if (_right != NULL)
+          _right->print(depth+1);
+      }
+    
+    if (_data_type == OPERATOR_UNARY)
+      {
+        std::cout << tab << "<unary>"
+                  << " "
+                  << ((_left   == NULL)?"left  == NULL (error)":"left  != NULL        ")
+                  << " "
+                  << ((_right  == NULL)?"right == NULL        ":"right != NULL (error)")
+                  << std::endl;
+        
+        if (_left  != NULL)
+          _left ->print(depth+1);
+        if (_right != NULL)
+          _right->print(depth+1);
+      }
+
+    if (_data_type == OPERATOR_BINARY)
+      {
+        std::cout << tab << "<binary>"
+                  << " "
+                  << ((_left   == NULL)?"left  == NULL (error)":"left  != NULL        ")
+                  << " "
+                  << ((_right  == NULL)?"right == NULL (error)":"right != NULL        ")
+                  << std::endl;
+
+        if (_left  != NULL)
+          _left ->print(depth+1);
+        if (_right != NULL)
+          _right->print(depth+1);
+      }
+  }
+
 };
 };
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_generate_file.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_generate_file.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_generate_file.cpp	(revision 88)
@@ -2,4 +2,5 @@
 #include "Behavioural/include/Stat.h"
 #include "Behavioural/include/Version.h"
+#include "Common/include/Environment.h"
 
 namespace morpheo {
@@ -8,4 +9,6 @@
   void Stat::generate_file (void)
   {
+    directory();
+
     std::string body = print(1);
 
@@ -26,6 +29,6 @@
     xml->balise_close();
 
-    xml->filename_extension ("stat");
-    xml->generate_file();
+    xml->filename_extension (".stat");
+    xml->generate_file(MORPHEO_STATISTICS);
 
     delete xml;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_have_counter.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_have_counter.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_have_counter.cpp	(revision 88)
@@ -10,7 +10,8 @@
 	 i!= _list_operand->end();
 	 ++i)
-      if (i->second.type == TYPE_COUNTER)
-	return true;
-
+      {
+        if (i->second.type == TYPE_COUNTER)
+          return true;
+      }
     return false;
   }
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_print.cpp	(revision 88)
@@ -7,4 +7,7 @@
   std::string Stat::print (uint32_t depth)
   {
+//     log_printf(TRACE,Behavioural,"Stat::print","Component name : %s",_name_component.c_str());
+//     log_printf(TRACE,Behavioural,"Stat::print","Instance  name : %s",_name_instance .c_str());
+
     end_simulation(); 
 
@@ -21,6 +24,7 @@
 	 stat != _list_stat->end();
 	 stat ++)
-      xml.text((*stat)->print(1));
-    
+      {
+        xml.text((*stat)->print(1));
+      }
 
     // Test special case
@@ -63,5 +67,5 @@
 		     ++operand)
 		  {
-		    if (operand->second.type == TYPE_COUNTER)
+ 		    if (operand->second.type == TYPE_COUNTER)
 		      {
 			xml.singleton_begin(operand->second.name);
@@ -80,6 +84,7 @@
 	  }
       }
+    
     xml.balise_close();
-
+    
     return xml.get_body(depth);
   }
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_string2tree.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_string2tree.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_string2tree.cpp	(revision 88)
@@ -5,125 +5,18 @@
 namespace behavioural {
 
-#define string2operator(x) (x=="+")?add:((x=="-")?sub:((x=="*")?mul:((x=="/" )?div:((x=="++")?inc:dec))))
-
   Stat_binary_tree * Stat::string2tree     (std::string expr)
   {
-    const std::string delims  (" ");          // délimiteur : " "
-    const std::string numbers ("0123456789"); // délimiteur : " "
-    std::string::size_type index_begin, index_end;
+    std::map<std::string, counter_t*> * operand = new std::map<std::string, counter_t*>;
 
-    Stat_binary_tree * tree = NULL;
+    for (std::map<std::string, var_t>::iterator it = _list_operand->begin();
+         it != _list_operand->end();
+         ++ it)
+      (*operand) [it->first] = it->second.counter;
 
-    index_begin = expr.find_first_not_of(delims);
+    Stat_binary_tree * tree = new Stat_binary_tree(expr,operand);
 
-    while (index_begin != std::string::npos)
-      {
-	index_end = expr.find_first_of(delims, index_begin);
-
-	if (index_end == std::string::npos)
-	  {
-	    index_end = expr.length();
-	  }
-	
-	std::string str = expr.substr(index_begin, index_end-index_begin);
-	
-	// 3 possibilités :
-	//  * operator
-	//  * constante
-	//  * variable
-	{
-	  // Test constantes
-	  std::string::size_type index = str.find_first_not_of(numbers);
-	  if (index  == std::string::npos)
-	    {
-// 	      std::cout << " * c'est une constante." << std::endl; 
-
-	      if (tree==NULL)
-		tree = new Stat_binary_tree (atoi(str.c_str()));
-	      else
-		tree = tree->insert_tree (atoi(str.c_str()));
-	    }
-	  else
-	    {
-	      // Test variables
-	      std::map<std::string, var_t>::iterator it = _list_operand->find(str);
-	      if (it != _list_operand->end())
-		{
-// 		  std::cout << " * c'est une variable." << std::endl; 
-
-		  if (tree==NULL)
-		    tree = new Stat_binary_tree (it->second.counter);
-		  else
-		    tree = tree->insert_tree (it->second.counter);
-		}
-	      else
-		{
-		  if ((str == "+") or
-		      (str == "-") or
-		      (str == "*") or
-		      (str == "/"))
-		    {
-// 		      std::cout << " * c'est un operator à 2 opérandes." << std::endl; 
-		      
-// 		      if (tree==NULL)
-// 			tree = new Stat_binary_tree (morpheo::string2operator[str].second);
-// 		      else
-// 			tree->insert_tree (morpheo::string2operator[str].second);
-		      if (tree==NULL)
-			tree = new Stat_binary_tree (string2operator(str));
-		      else
-			tree = tree->insert_tree (string2operator(str));
-		    }
-		  else
-		    {
-		      if ((str == "++") or
-			  (str == "--"))
-			{
-// 			  std::cout << " * c'est un operator à 1 opérande." << std::endl; 
-
-// 			  if (tree==NULL)
-// 			    tree = new Stat_binary_tree (string2operator[str.c_str()]);
-// 			  else
-// 			    tree->insert_tree (string2operator[str.c_str()]);
-
-			  if (tree==NULL)
-			    tree = new Stat_binary_tree (string2operator(str));
-			  else
-			    tree = tree->insert_tree (string2operator(str));
-			  
-			}
-		      else
-			{
-// 			  std::cout << " * c'est autre chose." << std::endl; 
-			  str = "expression '"+str+"' doesn't a constant, a declarated variable or an operator.";
-			  throw(ERRORMORPHEO("Stat::string2tree",_(str.c_str())));
-			}
-		    }
-		}
-	    }
-	}
-
-	index_begin = expr.find_first_not_of(delims, index_end);
-
-	if (index_begin != std::string::npos)
-	  tree = tree->goto_next_root();
-      }
-
-    if (tree == NULL)
-      throw (ERRORMORPHEO("Stat::string2tree",_("the tree generated is empty.")));
-
-//     std::cout << "<Stat::string2tree> goto_top_level" << std::endl;
-
-    tree = tree->goto_top_level();
-
-//     std::cout << "<Stat::string2tree> valid" << std::endl;
-
-    if (not tree->valid())
-      throw (ERRORMORPHEO("Stat::string2tree",_("the tree generated is invalid.")));
-
-//     std::cout << "<Stat::string2tree> End" << std::endl;
+    delete operand;
 
     return tree;
-
   }
   
